/*
 $(window).load(function(){
 $("ul").carousel({
 size: 2,
 speed: 300,
 visible: 7,
 vertical: true or false,
 elScroll: tag or class element,
 scrolling: true or false,
 scrollTime: 7000,
 responsive: true or false,
 responsiveMargin: margin for one side in %,
 btnPrev: html code or text for button prev,
 btnNext: html code or text for button next
 });
 });+
 */
(function($) {
	$.fn.carousel = function(o) {
		o = $.extend({
			size: 1,
			speed: 200,
			visible: 5,
			vertical: false,
			elScroll: false,
			scrolling: false,
			scrollTime: 7000,
			responsive: false,
			responsiveMargin: 0,
			btnPrev: '',
			btnNext: ''
		}, o || {});
		return this.each(function() {

			var ul = $(this), li = o.elScroll ? $(this).children(o.elScroll) : ul.children(), liLength = li.length, v = o.visible,  size = o.size>(liLength-v) ? liLength-v : o.size;

			if(v>=liLength){ return false; }

			//Code for the wrapper
			$(this).children().wrapAll(
				'<div class="carousel-clip">'+
					'<div class="carousel-wrap"></div>'+
					'</div>'
			);
			if(o.btnPrev || o.btnNext){
				$('.carousel-clip', this).append($('<a>').addClass("prev").attr({title:"Prev", onselectstart:"return false", unselectable:"on"}).html(o.btnPrev));
				$('.carousel-clip', this).append($('<a>').addClass("next").attr({title:"Next", onselectstart:"return false", unselectable:"on"}).html(o.btnNext));
				$('.carousel-clip', this).css({
					'-moz-user-select': 'none',
					'-khtml-user-select': 'none',
					'-webkit-user-select': 'none',
					'-o-user-select': 'none',
					'user-select': 'none'
				});
			}

			var div = $('.carousel-wrap', this),
				liW = Math.floor(li.width()), liFullWidth = Math.floor(li.outerWidth(true)),
				liH = Math.floor(li.height()), liFullHeight = Math.floor(li.outerHeight(true));
			li.each(function(){
				if(liW < Math.floor($(this).width())){
					liW = Math.floor($(this).width());
					liFullWidth = Math.floor($(this).outerWidth(true));
				}
				if(liH < Math.floor($(this).height())){
					liH = Math.floor($(this).height());
					liFullHeight = Math.floor($(this).outerHeight(true));
				}
			});

			ul.css({
				'overflow':'hidden',
				'width':o.vertical ? '' : (o.responsive ? '100%' : liFullWidth*v),
				'height':o.vertical ? liFullHeight*v : ''
			});
			$(this).find('.carousel-wrap').css({
				'margin':'0',
				'padding':'0',
				'width': o.vertical ? (o.responsive ? '100%' : liFullWidth) : (o.responsive ? 100*liLength/v+'%' : liFullWidth*liLength),
				'height': o.vertical ? liFullHeight*liLength : ''
			});
			li.css({
				'width': o.responsive ? 100/liLength-o.responsiveMargin*2 +'%' : liW,
				'height': o.vertical ? liH : '',
				'float': "left",
			});

			if(!o.vertical){
				// Prev button
				$('.prev', this).click(function(){ prevHorizontal(); });
				// Next button
				$('.next', this).click(function(){ nextHorizontal(); });
				o.scrolling || !o.btnPrev || !o.btnNext ? setInterval(nextHorizontal, o.scrollTime) : '';
			}
			else{
				// Prev button
				$('.prev', this).click(function(){ prevVertical(); });
				// Next button
				$('.next', this).click(function(){ nextVertical(); });
				o.scrolling || !o.btnPrev || !o.btnNext ? setInterval(nextVertical, o.scrollTime) : '';
			};

			// Prev button horizontal
			function prevHorizontal(){
				$(div).children(':gt('+ (liLength-size-1) +')').prependTo(div);
				$(div).stop(false, false).css({"margin-left": (o.responsive ? -100*size/v +'%' : -liFullWidth*size +'px')}).animate({'marginLeft': "0px"}, o.speed);
			}
			// Next button horizontal
			function nextHorizontal(){
				$(div).stop(true, true).animate({'marginLeft': (o.responsive ? -100*size/v +'%' : -liFullWidth*size +'px')}, o.speed, function () {
					$(div).children(':lt('+ size +')').appendTo(div);
					$(div).css({"margin-left":"0px"});
				});
			}
			// Prev button vertical
			function prevVertical(){
				$(div).children(':gt('+ (liLength-size-1) +')').prependTo(div);
				$(div).stop(false, false).css({"margin-top": -liFullHeight*size +'px'}).animate({'marginTop': "0px"}, o.speed);
			}
			// Next button vertical
			function nextVertical(){
				$(div).stop(true, true).animate({'marginTop': -liFullHeight*size +'px'}, o.speed, function () {
					$(div).children(':lt('+ size +')').appendTo(div);
					$(div).css({"margin-top":"0px"});
				});
			}
		});
	};
})(jQuery);
